using System;
using System.Runtime.InteropServices;

namespace TileWin {
    public class Native {
        [DllImport("user32.dll", CharSet=CharSet.Unicode)]
        public static extern long GetWindowLongPtr(IntPtr hWnd, int nIndex);
        
        [DllImport("user32.dll", CharSet=CharSet.Unicode)]
        public static extern long SetWindowLongPtr(IntPtr hWnd, int nIndex, long dwNewLong);

        [DllImport("user32.dll", CharSet=CharSet.Unicode)]
        public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("user32.dll")]
        public static extern int SetWindowPos(IntPtr hWnd, IntPtr hWndAfter, int x, int y, int cx, int cy, int flags);
        
        [DllImport("user32.dll")]
        public static extern int EnumWindows(EnumWindowsProc lpEnumProc, int lParam);

        [DllImport("user32.dll")]
        public static extern IntPtr WindowFromPoint(POINT Point);

        [DllImport("user32.dll", CharSet=CharSet.Unicode)]
        public static extern int SendMessage(IntPtr hWnd, int uMsg, int wParam, int lParam);

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();
        public const int WS_CAPTION = 0x00C0000;
        public const int GWL_STYLE = -16;
        public const int WM_CLOSE = 0x0010;

        public delegate bool EnumWindowsProc(IntPtr hWnd, int lParam);

        public struct POINT {
            public long X;
            public long Y;
        }
    }
}